﻿using System;
using System.Collections.Generic;  // !
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;          // !
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private string[] monate = { "Januar", "Februar", "März", 
                       "April", "Mai", "Juni", 
                       "Juli", "August", "September",
                       "Oktober", "November", "Dezember" };

        // Query Expression Syntax:
        private void button1_Click(object sender, EventArgs e)
        {
            var expr = from s in monate
                                       where s.Length == 6
                                       orderby s
                                       select s.ToUpper();

            foreach (string item in expr)
                listBox1.Items.Add(item);
        }

        // Extension Method Syntax:
        private void button2_Click(object sender, EventArgs e)
        {
            var expr = monate
                                       .Where(s => s.Length == 6)
                                       .OrderBy(s => s)
                                       .Select(s => s.ToUpper());

            foreach (string item in expr)
                listBox1.Items.Add(item);
        }

        // Gemischte Syntax:
        private void button3_Click(object sender, EventArgs e)
        {
            var expr = (from s in monate
                                       where s.Length == 6
                                       select s.ToUpper()).
                                       OrderBy(s => s);

            foreach (string item in expr)
                listBox1.Items.Add(item);

        }


    }
}
