using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Data.OleDb;

namespace TextBegrenzung
{
    public partial class Form1 : Form
    {

        private OleDbConnection conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Nordwind.mdb;");

        public Form1()
        {
            InitializeComponent();

            // -------------------------------------------------------------------
            try
            {
                conn.Open();
                showKundenTable();
                setMaxLength();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message.ToString());
            }
            finally
            {
                conn.Close();
            }
        }

        // Anzeigen der Kundentabelle:
        private void showKundenTable()
        {
            OleDbDataAdapter da = new OleDbDataAdapter(
                       "SELECT KundenCode, Firma, Kontaktperson, Funktion FROM Kunden", conn);
            DataTable dt = new DataTable();
            da.Fill(dt);
            // Steuerelemente anbinden:
            label1.DataBindings.Add("Text", bindingSource1, "KundenCode");
            textBox1.DataBindings.Add("Text", bindingSource1, "Firma");
            textBox2.DataBindings.Add("Text", bindingSource1, "Kontaktperson");
            textBox3.DataBindings.Add("Text", bindingSource1, "Funktion");
            // BindingSource mit DataTable synchronisieren:
            bindingSource1.DataSource = dt;
        }

        // Herauslesen und Anzeige der Spaltenlngen aus der Kundentabelle und Anpassen der Textboxen:
        private void setMaxLength()
        {
            // Schemainformationen fr Kunden-Tabelle holen:
            string[] filter = new string[] { null, null, "Kunden", null };
            DataTable dt = conn.GetSchema("Columns", filter);
            // alle Zeilen der Schema-Tabelle durchlaufen:
            for (int i = 0; i < dt.Rows.Count; i++) // in jeder Zeile sind die Infos zu einer bestimmten Spalte enthalten
            {
                string fName = dt.Rows[i]["COLUMN_NAME"].ToString();                 // Name der Spalte
                int fLen = Convert.ToInt32(dt.Rows[i]["CHARACTER_MAXIMUM_LENGTH"]);  // zulssige Anzahl von Zeichen
                switch (fName)
                {
                    case "Firma": textBox1.MaxLength = fLen;
                        label7.Text = fLen.ToString(); break;
                    case "Kontaktperson": textBox2.MaxLength = fLen;
                        label8.Text = fLen.ToString(); break;
                    case "Funktion": textBox3.MaxLength = fLen;
                        label9.Text = fLen.ToString(); break;
                }
            }
        }
    }
}