using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;



namespace WindowsApplication1
{
    using System.Data.SqlClient;     

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private string CrLf = Environment.NewLine;
        private SqlConnection conn = null;

        private void showMessage()
        {
            MessageBox.Show("Die Verbindung wurde erfolgreich hergestellt !" + CrLf +
                   "Data Source: " + conn.DataSource + CrLf +
                   "Server Version: " + conn.ServerVersion);
        }


       // mit CSB:
        private void button2_Click(object sender, EventArgs e)
        {
           
            SqlConnectionStringBuilder csb = new SqlConnectionStringBuilder();
            csb.DataSource = ".\\SQLEXPRESS";
            csb.IntegratedSecurity = true;
            csb.InitialCatalog = "Northwind";
            conn = new SqlConnection(csb.ConnectionString);
            try
            {
                conn.Open();
                showMessage();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                conn.Close();
            }
        }

        // ohne CSB:
        private void button3_Click(object sender, EventArgs e)
        {
            string connStr = "Data Source = .\\SQLEXPRESS; Initial Catalog=Northwind; Integrated Security=true";
            conn = new SqlConnection(connStr);
            try
            {
                conn.Open();
                showMessage();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                conn.Close();
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            string connStr = Properties.Settings.Default.connStr;
            MessageBox.Show(connStr);
            conn = new SqlConnection(connStr);
            try
            {
                conn.Open();
                showMessage();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                conn.Close();
            }
        }

    }
}