using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DataViewSearch_Demo
{
    using System.Data.OleDb;

    public partial class Form1 : Form
    {
        private DataView dv = null;
        private DataTable dt = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            OleDbConnection conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Nordwind.mdb;");
          	OleDbCommand cmd = new OleDbCommand("SELECT * FROM Kunden", conn);
          	OleDbDataAdapter da = new OleDbDataAdapter(cmd);
          	dt = new DataTable("Kundenliste");
          	conn.Open();
          	da.Fill(dt);
          	conn.Close();
          	dv = dt.DefaultView;
          	
            // Die bertragung der Spaltenbezeichner in die ComboBox:
	        foreach (DataColumn c in dt.Columns)
	        {
		        comboBox1.Items.Add(c.ColumnName);
	        }
          	comboBox1.SelectedIndex = 5;       	// Spalte "Ort" anzeigen
          	textBox1.Text = "London";          	// Default-Suchbegriff

            dataGridView1.DataSource = dv;
        }

        // FindRows-Methode:
        private void button1_Click(object sender, EventArgs e)
        {
            dv.Sort = comboBox1.Text;            // vorher muss sortiert werden
          	DataRowView[] arr;                   //  beachte die Array-Klammern [] !
          	arr = dv.FindRows(textBox1.Text);    // Array wird mit gesuchten Datenstzen gefllt    
            // Array-Inhalt in eine weitere DataTable zu kopieren, um Datenstze bequem anzeigen zu knnen1: 
	        DataTable dt2 = dt.Clone();    	       // neue leere DataTable erzeugen, Schema entspricht der ersten Tabelle 
          	for (int i = 0; i < arr.Length; i++)    // alle Array-Zeilen durchlaufen  
	        {   
                DataRow rw = dt2.NewRow();                 	// neue Zeile mit Schema der DataTable erzeugen
	            for (int j = 0; j < dt2.Columns.Count; j++)   	// alle Array-Spalten durchlaufen
	    	         rw[j] = arr[i][j];       	// DataRow-Feld mit Wert der Array-Zelle fllen 
	            dt2.Rows.Add(rw);         		// DataRow zur DataTable hinzuaddieren 
	        } 
            dataGridView1.DataSource = dt2;  		// alle gefundenen Datenstze werden angezeigt
        }

        
        // Find-Methode:
        private void button3_Click(object sender, EventArgs e)
        {
            dataGridView1.DataSource = dv;
            dv.Sort = comboBox1.Text;
            int i = dv.Find(textBox1.Text);
            if (i < 0)
                MessageBox.Show("Keinen Datensatz gefunden!");
            else
            {
                    dataGridView1.CurrentCell = dataGridView1.Rows[i].Cells[0];   // Markieren der ersten gefundenen Zeile 
               
            }
        }

        // Reset:
        private void button2_Click(object sender, EventArgs e)
        {
            dataGridView1.DataSource = dt;
        }
    }
 }
