using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Data.SqlClient;

namespace DataSet_DataReader
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //const string CONNSTR = "Data Source=.\\SQLEXPRESS; Initial Catalog=Northwind; Integrated Security=sspi;";
        const string CONNSTR = @"Data Source=.\SQLEXPRESS;AttachDbFilename=|DataDirectory|\Northwind.mdf;" +
                                                       "Integrated Security=True;User Instance=True";                      
        const string SQL = "SELECT * FROM Customers ORDER BY CompanyName";

        private void showReader(IDataReader dr)
        {
            string str;
            string spc = "   ";
            listBox1.Items.Clear();
            while (dr.Read())
            {
                str = dr["CustomerID"] + spc;
                str += dr["CompanyName"] + spc;
                str += dr["ContactName"] + spc;
                str += dr["ContactTitle"] + spc;
                str += dr["Address"] + spc;
                str += dr["City"] + spc;
                listBox1.Items.Add(str);
            }
            dr.Close();
        }

        // DataTable => DataReader:
        private void button1_Click(object sender, EventArgs e)
        {
            SqlConnection conn = new SqlConnection(CONNSTR);
            try
            {
                conn.Open();
                SqlCommand cmd = new SqlCommand(SQL, conn);
                SqlDataAdapter da = new SqlDataAdapter(cmd);
                DataTable dt = new DataTable();
                da.Fill(dt);
                
                // Die neue Klasse DataTableReader implementiert die IDataReader-Schnittstelle:
                DataTableReader dtr = new DataTableReader(dt);
                showReader(dtr);
            }
            catch (SqlException ex)
            { MessageBox.Show(ex.Message); }
            catch (InvalidOperationException ex)
            { MessageBox.Show(ex.Message); }
            catch (Exception ex)
            { MessageBox.Show(ex.Message); }
            finally
            { conn.Close(); }
        }

        // DataReader => DataTable:
        private void button2_Click(object sender, EventArgs e)
        {
            SqlConnection conn = new SqlConnection(CONNSTR);
            try
            {
                conn.Open();
                SqlCommand cmd = new SqlCommand(SQL, conn);
                SqlDataReader dr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                DataTable dt = new DataTable();

                // Die neue Methode Load() ermglicht die bernahme eines DataReader:
                dt.Load(dr, LoadOption.OverwriteChanges);
                dataGridView1.DataSource = dt;
            }
            catch (SqlException ex)
            { MessageBox.Show(ex.Message); }
            catch (InvalidOperationException ex)
            { MessageBox.Show(ex.Message); }
            catch (Exception ex)
            { MessageBox.Show(ex.Message); }
            finally
            { conn.Close(); }
        }

       

    }
}