using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Firma
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

         private CFirma _firma = new CFirma();
         private const string PFAD = "Bestellungen.dat";

        protected override void OnLoad(EventArgs e)
        {
           try
           {
               _firma = (CFirma) CPersistent.loadObject(PFAD);
           }
           catch (Exception ex)
           {
               MessageBox.Show(ex.Message);
           }
           bsKunden.DataSource = _firma.Kunden;

           textBox1.DataBindings.Add(new Binding("Text", bsKunden, "Vorname", true));
           textBox2.DataBindings.Add(new Binding("Text", bsKunden, "Nachname", true));
           textBox3.DataBindings.Add(new Binding("Text", bsKunden, "Adresse", true));
           checkBox1.DataBindings.Add(new Binding("Checked", bsKunden, "Stammkunde", true));
                      
           base.OnLoad(e);
        }

        private void bsKunden_CurrentChanged(object sender, EventArgs e)
        {
           CKunde kunde = (CKunde) bsKunden.Current;
           bsBestellungen.DataSource = kunde.Bestellungen;
           textBox4.DataBindings.Clear();
           textBox4.DataBindings.Add("Text", bsBestellungen, "Datum", true);
           textBox5.DataBindings.Clear();
           textBox5.DataBindings.Add("Text", bsBestellungen, "Netto", true);
           textBox6.DataBindings.Clear();
           textBox6.DataBindings.Add("Text", bsBestellungen, "Bemerkung", true);

           dataGridView1.DataSource = bsBestellungen;
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            try
            {
                CPersistent.saveObject(_firma, PFAD);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            base.OnClosing(e);
        }

    }
}