using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DataBinding_Manuell
{
    using System.Data.OleDb;

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        private OleDbDataAdapter da;
        private DataTable dt;

        private BindingSource bs = new BindingSource();

        private void Form1_Load(object sender, EventArgs e)
        {
            string connStr = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=Nordwind.mdb;";
            OleDbConnection conn = new OleDbConnection(connStr);

            string selStr = "SELECT PersonalNr, Vorname, Nachname, Funktion, Geburtsdatum, Monatsgehalt FROM Personal";
            da = new OleDbDataAdapter(selStr, conn);
            OleDbCommandBuilder cb = new OleDbCommandBuilder(da);
            da.SelectCommand = new OleDbCommand(selStr, conn);      // nicht notwendig!

            dt = new DataTable("Personal");
            conn.Open();
            da.Fill(dt);
            conn.Close();

            bs.DataSource = dt;

            label1.DataBindings.Add("Text", bs, "PersonalNr");
            textBox1.DataBindings.Add("Text", bs, "Vorname");
            textBox2.DataBindings.Add("Text", bs, "Nachname");

            Binding b1 = new Binding("Text", bs, "Geburtsdatum");
            b1.Format += new ConvertEventHandler(this.DateToDateString);    // Aufruf der Formatierungsroutine (s.u.)
            b1.Parse += new ConvertEventHandler(this.DateStringToDate);     // dto.
            textBox3.DataBindings.Add(b1);

            textBox4.DataBindings.Add("Text", bs, "Funktion");

            Binding b2 = new Binding("Text", bs, "Monatsgehalt");
            b2.Format += new ConvertEventHandler(this.DecToCurrString);    // Aufruf der Formatierungsroutine (s.u.)
            b2.Parse += new ConvertEventHandler(this.CurrStringToDec);     // dto.
            textBox5.DataBindings.Add(b2);

            bindingNavigator1.BindingSource = bs;   // !
        }

        // Implementierung der Eventhandler fr die Datumsanzeige:
        private void DateToDateString(object sender, ConvertEventArgs e)    // Datenquelle => Anzeige
        {
            try
            { e.Value = Convert.ToDateTime(e.Value).ToString("d.M.yyyy"); }
            catch { }
        }

        private void DateStringToDate(object sender, ConvertEventArgs e)       // Anzeige => Datenquelle
        {
            e.Value = Convert.ToDateTime(e.Value);
        }

        // Implementierung der Eventhandler fr die Whrungsanzeige:
        private void DecToCurrString(object sender, ConvertEventArgs e)     // Datenquelle => Anzeige
        {
            //if (e.DesiredType != typeof(string)) return;
            try
            { e.Value = ((decimal)e.Value).ToString("c"); }
            catch { }
        }

        private void CurrStringToDec(object sender, ConvertEventArgs e)       // Anzeige => Datenquelle
        {
            e.Value = Convert.ToDecimal(e.Value);
        }

        // Speichern
        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            bs.EndEdit();
            da.Update(dt);
        }

        // Abbrechen
        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            bs.CancelEdit();
        }
    }


        
 }
