﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Firmenverwaltung : System.Web.UI.Page
{
    FirmaTableAdapters.MitarbeiterTableAdapter taMitarbeiter = new FirmaTableAdapters.MitarbeiterTableAdapter();
    FirmaTableAdapters.TelefonTableAdapter taTelefone = new FirmaTableAdapters.TelefonTableAdapter();
    Firma myFirma = new Firma();

    protected void Refresh()
    {
        taMitarbeiter.Fill(myFirma.Mitarbeiter);
        if (GridView1.SelectedValue == null)
            taTelefone.Fill(myFirma.Telefon);
        else
            taTelefone.FillByMitarbeiter(myFirma.Telefon, (int)GridView1.SelectedValue);
        GridView1.DataSource = myFirma.Mitarbeiter;
        GridView2.DataSource = myFirma.Telefon;
        this.DataBind();
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        Refresh();
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        myFirma.Mitarbeiter.AddMitarbeiterRow(TextBox1.Text, TextBox2.Text, Convert.ToDecimal(TextBox3.Text));
        taMitarbeiter.Update(myFirma.Mitarbeiter);
        Refresh();
    }

    protected void Button2_Click(object sender, EventArgs e)
    {
        if (GridView1.SelectedValue == null) return;
        Firma.TelefonRow tr = myFirma.Telefon.NewTelefonRow();
        tr.MitarbeiterId = (int) GridView1.SelectedValue;
        tr.Nummer = TextBox7.Text;
        myFirma.Telefon.AddTelefonRow(tr);
        taTelefone.Update(myFirma.Telefon);
        Refresh();
    }

    protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
    {
        Refresh();
    }

    protected void Button3_Click(object sender, EventArgs e)
    {
        int id = Convert.ToInt32(taMitarbeiter.NeuerMitarbeiter(TextBox5.Text, TextBox4.Text, 100));
        taTelefone.Insert(TextBox6.Text, id);
        Refresh();
    }
    protected void Button4_Click(object sender, EventArgs e)
    {
        // alternativ
        if (GridView1.SelectedValue == null) return;
        taTelefone.Insert(TextBox7.Text, (int)GridView1.SelectedValue);
        Refresh();
    }
    protected void GridView2_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        Response.Write(e.Values[0]);
    }

    protected void Button5_Click(object sender, EventArgs e)
    {

        foreach (Firma.MitarbeiterRow row in myFirma.Mitarbeiter)
        {
            Response.Write("Name " + row.vorname + " " + row.nachname + " Gehalt: " + row.gehalt.ToString("c") + "<br>");
        }
    }
}
