using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.ComponentModel;

[DataObject(true)]
public class Warenkorb
{
    private  List<Artikel> _ArtikelListe;
    private  int Counter = 1;

    public Warenkorb()
    {
       _ArtikelListe = new List<Artikel>();
    }

    [DataObjectMethod(DataObjectMethodType.Select)]
    public  List<Artikel> GetArtikelListe()
    {
        SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["DatenConnectionString2"].ConnectionString);
        SqlCommand cmd = new SqlCommand("SELECT * FROM warenkorb", conn);
        conn.Open();
        SqlDataReader dr = cmd.ExecuteReader();
        while (dr.Read())
            _ArtikelListe.Add(new Artikel((string) dr["Bezeichnung"],(double) dr["Preis"], (int) dr["Anzahl"],(int) dr["id"] ));
        dr.Close();
        conn.Close();
        return _ArtikelListe;
    }

    [DataObjectMethod(DataObjectMethodType.Update)]
    public void UpdateArtikel(Artikel updArtikel)
    {
        SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["DatenConnectionString2"].ConnectionString);
        SqlCommand cmd = new SqlCommand("UPDATE warenkorb SET [Bezeichnung]=@bez, [Preis]=@preis, [Anzahl]=@anz WHERE [ID]=@id", conn);
        cmd.Parameters.AddWithValue("@bez", updArtikel.Bezeichnung);
        cmd.Parameters.AddWithValue("@preis", updArtikel.Preis);
        cmd.Parameters.AddWithValue("@anz", updArtikel.Anzahl);
        cmd.Parameters.AddWithValue("@id", updArtikel.Id);
        conn.Open();
        cmd.ExecuteNonQuery();
        conn.Close();
    }

    [DataObjectMethod(DataObjectMethodType.Delete)]
    public  void DeleteArtikel(Artikel delArtikel)
    {
        SqlConnection conn = new SqlConnection(ConfigurationManager.ConnectionStrings["DatenConnectionString2"].ConnectionString);
        SqlCommand cmd = new SqlCommand("DELETE FROM warenkorb WHERE [ID]=@id", conn);
        cmd.Parameters.AddWithValue("@id", delArtikel.Id);
        conn.Open();
        cmd.ExecuteNonQuery();
        conn.Close();
    }

    [DataObjectMethod(DataObjectMethodType.Insert)]
    public  void InsertArtikel(Artikel insArtikel)
    {
    }


}
