using System;
using System.Collections.Generic;
using System.Text;

namespace Spesen
{
    public static class CSpesen
    {
        // Hilfsprozedur fr Verpflegungspauschale fr An- oder Abreisetag lt. Spesentabelle
        // dat1 und dat2 sind DatumZeit-Werte vom gleichen Tag!
        private static decimal oneDay(DateTime dat1, DateTime dat2)
        {
            decimal betrag = 0;
            int stunden = (dat2 - dat1).Hours;       // liefert abgerundete Stunden aus Datumsdifferenz!
            if (stunden >= 8) betrag += 6.0M;        //  6 Euro ab  8 Stunden 
            if (stunden >= 14) betrag += 6.0M;       // 12 Euro ab 14 Stunden
            return (betrag);
        }

        // Hauptprozedur fr Verpflegungspauschale:
        public static decimal getSpesen(DateTime beginn, DateTime ende)
        {
            decimal vp = 0;   // V-Pauschale
            // Hilfsvariablen d1 und d2 sind ohne Zeitanteil:
            string sd1 = beginn.ToShortDateString();
            DateTime d1 = Convert.ToDateTime(sd1);  // 0-Uhr am Anreisetag
            string sd2 = ende.ToShortDateString();
            DateTime d2 = Convert.ToDateTime(sd2);  // ........ Abreisetag

            int tage = (d2 - d1).Days + 1;          // Reisedauer in Tagen
            if (tage == 1) vp += oneDay(beginn, ende);  // eintgige Reise
            if (tage > 1)
            {
                DateTime d1E = d1.AddDays(1);       // Ende des Anreisetags (0-Uhr am zweiten Tag)
                vp += oneDay(beginn, d1E);          // Spesen fr Anreisetag
                vp += oneDay(d2, ende);             // ......     Abreisetag
            }
            if (tage > 2) vp += 24.0M * (tage - 2);   // 24 Euro fr vollen Tag
            return (vp);
        }
    }
}
