﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Data.OleDb;
using System.IO;


namespace ADOX
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void Button1_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            catalog.Create("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb");
        }

        private void Button2_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb;";
            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;
        }

        private void Button3_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            ADOX.Table table = new ADOX.Table();

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb";
            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;
            table.Name = "Kundenstammdaten";
            table.Columns.Append("Nachname", DataTypeEnum.adVarWChar, 50);
            table.Columns.Append("Vorname", DataTypeEnum.adVarWChar, 50);
            catalog.Tables.Append(table);

        }

        private void Button4_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            ADOX.Table table = new ADOX.Table();

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb";
            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;
            table = catalog.Tables["Kundenstammdaten"];
            MessageBox.Show(table.Columns["Nachname"].Type.ToString());

        }

        private void Button5_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            ADOX.Table table = new ADOX.Table();
            ADOX.Column column;
            ADOX.Index index;

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb";
            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;
            table = catalog.Tables["Kundenstammdaten"];

            column = new ADOX.Column();
            column.ParentCatalog = catalog;
            column.Name = "Id";
            column.Type = DataTypeEnum.adInteger;
            column.Properties["Nullable"].Value = false;
            column.Properties["Jet OLEDB:Allow Zero Length"].Value = false;
            column.Properties["AutoIncrement"].Value = true;

            table.Columns.Append(column, ADOX.DataTypeEnum.adIUnknown, 0);

            index = new ADOX.Index();
            index.Name = "PrimaryKey";
            index.PrimaryKey = true;
            index.Columns.Append("Id", table.Columns["Id"].Type, table.Columns["Id"].DefinedSize);
            table.Indexes.Append(index, null);

            index = new ADOX.Index();
            index.Name = "NachnameVorname";
            index.Unique = true;
            index.Columns.Append("Nachname", table.Columns["Nachname"].Type, table.Columns["nachname"].DefinedSize);
            index.Columns.Append("Vorname", table.Columns["Vorname"].Type, table.Columns["Vorname"].DefinedSize);
            table.Indexes.Append(index, null);

        }

        private void Button6_Click(object sender, System.EventArgs e)
        {

            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            ADOX.Table table = new ADOX.Table();
            ADOX.Index index = new ADOX.Index();

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb";
            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;
            table = catalog.Tables["Kundenstammdaten"];

            index.Name = "Nachname";
            index.Columns.Append("Nachname", table.Columns["Nachname"].Type, table.Columns["Nachname"].DefinedSize);
            table.Indexes.Append(index, null);

        }

        private void Button7_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            ADODB.Command cmd = new ADODB.Command();

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb";
            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;

            cmd.CommandText = "SELECT * FROM Kundenstammdaten;";
            cmd.CommandType = ADODB.CommandTypeEnum.adCmdText;
            catalog.Views.Append("Abfrage_Test_1", cmd);

        }

        private void Button8_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            ADODB.Command cmd = new ADODB.Command();

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb";
            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;

            cmd.CommandText = "PARAMETERS [name] Text; SELECT * FROM Kundenstammdaten WHERE nachname = [name];";
            cmd.CommandType = ADODB.CommandTypeEnum.adCmdText;
            catalog.Procedures.Append("Abfrage_Test_2", cmd);

        }

        private void Button9_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            ADODB.Command cmd = new ADODB.Command();
            ADOX.Key key;

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb";
            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;

            key = new ADOX.Key();
            key.Name = "RaumPerson";
            key.Type = KeyTypeEnum.adKeyForeign;
            key.RelatedTable = "Raeume";
            key.Columns.Append("RaumID", catalog.Tables["Personen"].Columns["RaumID"].Type,
                               catalog.Tables["Personen"].Columns["RaumID"].DefinedSize);
            key.Columns["RaumId"].RelatedColumn = "Id";
            key.DeleteRule = RuleEnum.adRICascade;
            catalog.Tables["Personen"].Keys.Append(key, ADOX.KeyTypeEnum.adKeyForeign, null, null, null);

        }

        private void Button10_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();

            catalog.Create("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\test.mdb;" +
            "JET OLEDB:System Database=.\\SYSTEM.MDW");
//            "JET OLEDB:System Database=.\\SYSTEM.MDW;Jet OLEDB:Database Password=geheim");

        }

        private void Button11_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();

            conn.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\test.mdb;" +
                                    @"Jet OLEDB:System database=C:\Dokumente und Einstellungen\Administrator\Anwendungsdaten\Microsoft\Access\SYSTEM.MDW";

            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;

            catalog.Groups.Append("Buchhalter");
            catalog.Users.Append("Müller", "");
            catalog.Users.Append("Braun", "");
            catalog.Users.Append("Chef", "");
            catalog.Users["Chef"].ChangePassword("", "pwChef");

        }

        private void Button12_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();

            conn.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\test.mdb;" +
              @"Jet OLEDB:System database=C:\Dokumente und Einstellungen\Administrator\Anwendungsdaten\Microsoft\Access\SYSTEM.MDW";

            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;
            catalog.Groups["Buchhalter"].Users.Append("Müller", "");
            catalog.Groups["Buchhalter"].Users.Append("Braun", "");
            catalog.Users["Braun"].SetPermissions("Gehälter", ObjectTypeEnum.adPermObjTable, ActionEnum.adAccessSet, RightsEnum.adRightFull, InheritTypeEnum.adInheritNone, null);
            catalog.Groups["Buchhalter"].SetPermissions("Gehälter", ObjectTypeEnum.adPermObjTable, ActionEnum.adAccessSet, RightsEnum.adRightRead, InheritTypeEnum.adInheritNone, null);

        }

        private void Button13_Click(object sender, System.EventArgs e)
        {
            JRO.JetEngine JE = new JRO.JetEngine();

            if (File.Exists("c:\\Test_BCK.mdb")) File.Delete("c:\\Test_BCK.mdb");
            JE.CompactDatabase(@"Data Source=c:\Test.mdb;Jet OLEDB:Database Password=test;",
               @"Data Source=c:\Test_BCK.mdb;Jet OLEDB:Encrypt Database=True;" +
               @"Jet OLEDB:Database Password=test");
            if (File.Exists("c:\\test_BCK.mdb")) File.Delete("c:\\Test.mdb");
            File.Copy("c:\\test_BCK.mdb", "c:\\test.mdb");
            if (File.Exists("c:\\Test.mdb")) File.Delete("c:\\Test_BCK.mdb");

        }

        private void Button14_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            conn.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\testdb.mdb";
            conn.Open(null, null, null, 0);

            listBox1.Items.Clear();
            for (int i = 0; i < conn.Properties.Count; i++)
            {
                try
                { listBox1.Items.Add(conn.Properties[i].Name + ": " + conn.Properties[i].Value.ToString()); }
                catch { }
            }


        }

        private void Button15_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            conn.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\testdb.mdb";
            conn.Open(null, null, null, 0);

            listBox1.Items.Clear();
            catalog.ActiveConnection = conn;
            // Alle Tabellen auflisten:
            for (int i = 0; i < catalog.Tables.Count; i++)
            {
                listBox1.Items.Add(catalog.Tables[i].Name);
                //Direkte Tabellen-Eigenschaften bestimmen:
                listBox1.Items.Add("    Typ        : " + catalog.Tables[i].Type);
                listBox1.Items.Add("    Erstellt am: " + catalog.Tables[i].DateCreated);
                listBox1.Items.Add("    Änderung am: " + catalog.Tables[i].DateModified);
                //Die Properties-Auflistung darstellen:
                listBox1.Items.Add("    Properties : ");
                for (int j = 0; j < catalog.Tables[i].Properties.Count; j++)
                {
                    try
                    {
                        listBox1.Items.Add("        " + catalog.Tables[i].Properties[j].Name + ": " +
                          catalog.Tables[i].Properties[j].Value);
                    }
                    catch { }
                }
                //Die Spalten anzeigen (über die Eigenschaft Type können Sie den Datentyp ermitteln):
                listBox1.Items.Add("    Spalten : ");
                for (int j = 0; j < catalog.Tables[i].Columns.Count; j++)
                    listBox1.Items.Add("        " + catalog.Tables[i].Columns[j].Name);

                //Die Indizes auslesen (in Klammern werden die zugehörigen Spalten angezeigt):
                listBox1.Items.Add("    Indizes : ");
                for (int j = 0; j < catalog.Tables[i].Indexes.Count; j++)
                {
                    string s = "";
                    for (int k = 0; k < catalog.Tables[i].Indexes[j].Columns.Count; k++)
                        s += catalog.Tables[i].Indexes[j].Columns[k].Name + " ";
                    listBox1.Items.Add("        " + catalog.Tables[i].Indexes[j].Name + " -> [" + s.Trim() + "]");
                }
                //Die Tabellenschlüssel bestimmen:
                listBox1.Items.Add("    Schlüssel: ");
                for (int j = 0; j < catalog.Tables[i].Keys.Count; j++)
                {
                    string s = "";
                    for (int k = 0; k < catalog.Tables[i].Keys[j].Columns.Count; k++)
                        s += catalog.Tables[i].Keys[j].Columns[k].Name + " ";
                    listBox1.Items.Add("        " + catalog.Tables[i].Keys[j].Name + " -> [" + s.Trim() + "]");
                }
            }

        }

        private void Button16_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            conn.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\testdb.mdb";
            conn.Open(null, null, null, 0);

            listBox1.Items.Clear();
            catalog.ActiveConnection = conn;

            for (int i = 0; i < catalog.Views.Count; i++)
            {
                listBox1.Items.Add(catalog.Views[i].Name);
                listBox1.Items.Add("    Erstellt am: " + catalog.Views[i].DateCreated);
                listBox1.Items.Add("    Änderung am: " + catalog.Views[i].DateModified);
                listBox1.Items.Add("    SQL        : " + (catalog.Views[i].Command as ADODB.Command).CommandText);
                for (int j = 0; j < (catalog.Views[i].Command as ADODB.Command).Properties.Count; j++)
                {
                    try
                    {
                        listBox1.Items.Add("      Property (" + (catalog.Views[i].Command as ADODB.Command).Properties[j].Name + ") : " +
                          (catalog.Views[i].Command as ADODB.Command).Properties[j].Value.ToString());
                    }
                    catch { }
                }
            }
        }

        private void Button17_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            conn.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\testdb.mdb";
            conn.Open(null, null, null, 0);

            listBox1.Items.Clear();
            catalog.ActiveConnection = conn;

            for (int i = 0; i < catalog.Procedures.Count; i++)
            {
                listBox1.Items.Add(catalog.Procedures[i].Name);
                listBox1.Items.Add("    Erstellt am: " + catalog.Procedures[i].DateCreated);
                listBox1.Items.Add("    Änderung am: " + catalog.Procedures[i].DateModified);
                listBox1.Items.Add("    Properties : ");
                listBox1.Items.Add("    SQL        : " + (catalog.Procedures[i].Command as ADODB.Command).CommandText);


                for (int j = 0; j < (catalog.Procedures[i].Command as ADODB.Command).Properties.Count; j++)
                {
                    try
                    {
                        listBox1.Items.Add("      Property (" + (catalog.Procedures[i].Command as ADODB.Command).Properties[j].Name + ") : " +
                          (catalog.Procedures[i].Command as ADODB.Command).Properties[j].Value.ToString());
                    }
                    catch { }
                }

                for (int j = 0; j < (catalog.Procedures[i].Command as ADODB.Command).Parameters.Count; j++)
                {
                    try
                    {
                        listBox1.Items.Add("      Parameter (" +
                          (catalog.Procedures[i].Command as ADODB.Command).Parameters[j].Name + ") : " + (catalog.Procedures[i].Command as ADODB.Command).Parameters[j].Value.ToString());
                    }
                    catch { }

                }
            }

        }

        private void Button18_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            conn.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\testdb.mdb";
            conn.Open(null, null, null, 0);

            listBox1.Items.Clear();
            catalog.ActiveConnection = conn;

            for (int i = 0; i < catalog.Groups.Count; i++)
            {
                listBox1.Items.Add(catalog.Groups[i].Name);
                for (int j = 0; j < catalog.Groups[i].Users.Count; j++)
                    listBox1.Items.Add(" --> " + catalog.Groups[i].Users[j].Name);
                listBox1.Items.Add("");
            }

        }

        private void RepairAndCompact(string name)
        {
            JRO.JetEngine JE = new JRO.JetEngine();

            if (File.Exists(name + ".BAK")) File.Delete(name + ".BAK");
            JE.CompactDatabase("Data Source=" + name, "Data Source=" + name + ".BAK");
            if (File.Exists(name + ".BAK")) File.Delete(name);
            File.Move(name + ".BAK", name);
        }


        private void Button19_Click(object sender, System.EventArgs e)
        {
            ADOX.RightsEnum rights;

            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            conn.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\testdb.mdb";
            conn.Open(null, null, null, 0);

            listBox1.Items.Clear();
            catalog.ActiveConnection = conn;

            listBox1.Items.Add("Admin");
            rights = catalog.Users["Admin"].GetPermissions("Mitarbeiter", ObjectTypeEnum.adPermObjTable, null);
            listBox1.Items.Add("   adRightReadDesign: " + ((rights & RightsEnum.adRightReadDesign) == RightsEnum.adRightReadDesign).ToString());
            listBox1.Items.Add("   adRightWriteDesign: " + ((rights & RightsEnum.adRightWriteDesign) == RightsEnum.adRightWriteDesign).ToString());
            listBox1.Items.Add("   adRightCreate: " + ((rights & RightsEnum.adRightCreate) == RightsEnum.adRightCreate).ToString());
            listBox1.Items.Add("   adRightDelete: " + ((rights & RightsEnum.adRightDelete) == RightsEnum.adRightDelete).ToString());
            listBox1.Items.Add("   adRightInsert: " + ((rights & RightsEnum.adRightInsert) == RightsEnum.adRightInsert).ToString());
            listBox1.Items.Add("");

            listBox1.Items.Add("Admins");
            rights = catalog.Groups["Admins"].GetPermissions("Mitarbeiter", ObjectTypeEnum.adPermObjTable, null);
            listBox1.Items.Add("   adRightReadDesign: " + ((rights & RightsEnum.adRightReadDesign) == RightsEnum.adRightReadDesign).ToString());
            listBox1.Items.Add("   adRightWriteDesign: " + ((rights & RightsEnum.adRightWriteDesign) == RightsEnum.adRightWriteDesign).ToString());
            listBox1.Items.Add("   adRightCreate: " + ((rights & RightsEnum.adRightCreate) == RightsEnum.adRightCreate).ToString());
            listBox1.Items.Add("   adRightDelete: " + ((rights & RightsEnum.adRightDelete) == RightsEnum.adRightDelete).ToString());
            listBox1.Items.Add("   adRightInsert: " + ((rights & RightsEnum.adRightInsert) == RightsEnum.adRightInsert).ToString());
            listBox1.Items.Add("");


        }

        private void Button20_Click(object sender, System.EventArgs e)
        {
            ADODB.Connection ado = new ADODB.Connection();
            MessageBox.Show(ado.Version.ToString());

        }

        private void Button21_Click(object sender, System.EventArgs e)
        {
            ADODB.Recordset rs;
            ADODB.Connection conn = new ADODB.Connection();

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb";
            conn.Open(null, null, null, 0);
            rs = conn.OpenSchema(ADODB.SchemaEnum.adSchemaProviderSpecific, null, "{947bb102-5d43-11d1-bdbf-00c04fb92675}");

            while (rs.EOF)
            {
                try
                {
                    listBox2.Items.Add("Computer: " + rs.Fields["COMPUTER_NAME"].Value.ToString());
                    listBox2.Items.Add("  Login: " + rs.Fields["LOGIN_NAME"].Value.ToString());
                }
                catch { }
                rs.MoveNext();
            }

        }

        private void Button22_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();
            ADOX.Table table = new ADOX.Table();
            ADOX.Column column;

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb";
            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;
            table = catalog.Tables["Kundenstammdaten"];

            column = new ADOX.Column();
            column.ParentCatalog = catalog;
            column.Name = "GUIDId";
            column.Type = DataTypeEnum.adGUID;
            column.Properties["Jet OLEDB:AutoGenerate"].Value = true;
            table.Columns.Append(column, ADOX.DataTypeEnum.adEmpty, 0);
        }

        private void SetNewDatabasePwd(string dbname, string oldpwd, string newpwd)
        {
            JRO.JetEngine JE = new JRO.JetEngine();

            if (File.Exists(dbname + ".BAK")) File.Delete(dbname + ".BAK");
            JE.CompactDatabase("Data Source=" + dbname + ";Jet OLEDB:Database Password=" + oldpwd,
                               "Data Source=" + dbname + ".BAK; Jet OLEDB:Database Password=" + newpwd);
            if (File.Exists(dbname + ".BAK")) File.Delete(dbname);
            File.Move(dbname + ".BAK", dbname);
        }

        private void button23_Click(object sender, System.EventArgs e)
        {
            ADOX.Catalog catalog = new ADOX.Catalog();
            ADODB.Connection conn = new ADODB.Connection();

            conn.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb;JET OLEDB:System Database=c:\\SYSTEM.MDW";
            conn.Open(null, null, null, 0);
            catalog.ActiveConnection = conn;
            MessageBox.Show(catalog.Tables["Mitarbeiter"].Columns["Gehalt"].Properties["Description"].Value.ToString());


        }

        private void TabPage3_Click(object sender, EventArgs e)
        {

        }

        private void button24_Click_1(object sender, EventArgs e)
        {
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            OleDbConnection conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb");
            DataTable dt = null;
            try
            {
                conn.Open();
                dt = conn.GetSchema("MetaDataCollections");
            }
            catch (Exception ex)
            {
                MessageBox.Show("Fehler: " + ex.Message);
                return;
            }
            finally
            {
                conn.Close();
            }
            dataGridView1.DataSource = dt;
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            OleDbConnection conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb");
            DataTable dt = null;
            try
            {
                conn.Open();
                dt = conn.GetSchema("Tables");
            }
            catch (Exception ex)
            {
                MessageBox.Show("Fehler: " + ex.Message);
                return;
            }
            finally
            {
                conn.Close();
            }
            dataGridView1.DataSource = dt;

        }

        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            OleDbConnection conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb");
            DataTable dt = null;
            String[] resValues = new String[4];
            resValues[2] = "Kundenstammdaten";
            
            try
            {
                conn.Open();
                dt = conn.GetSchema("Columns", resValues);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Fehler: " + ex.Message);
                return;
            }
            finally
            {
                conn.Close();
            }
            dataGridView1.DataSource = dt;

        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            OleDbConnection conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=c:\\testdb.mdb");
            DataTable dt = null;
            String s = (string) toolStripComboBox1.SelectedItem;
            try
            {
                conn.Open();
                dt = conn.GetSchema(s);
            }
            catch (Exception ex)
            {
                MessageBox.Show("Fehler: " + ex.Message);
                return;
            }
            finally
            {
                conn.Close();
            }
            dataGridView1.DataSource = dt;

        }

        private void button24_Click(object sender, EventArgs e)
        {
        }

        private void toolStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void tabPage5_Click(object sender, EventArgs e)
        {

        }

        private void button24_Click_2(object sender, EventArgs e)
        {
        }

    }
}
