/****
VORSICHT
  Überprüfen Sie dieses Skript ausführlich, bevor Sie es ausführen, 
  um mögliche Probleme wegen Datenverlusten zu vermeiden.

Dieses SQL-Skript wurde mit dem Dialogfeld "Datensynchronisierung konfigurieren"
generiert. Dieses Skript ergänzt das Skript, mit dem die
erforderlichen Datenbankobjekte für die Änderungsnachverfolgung erstellt werden können. Dieses
Skript enthält Anweisungen zum Entfernen solcher Änderungen.

Weitere Informationen finden Sie im Hilfethema "How to: Configure a Database Server for Synchronization".
****/


IF @@TRANCOUNT > 0
set ANSI_NULLS ON 
set QUOTED_IDENTIFIER ON 

GO
BEGIN TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Order Details] DROP CONSTRAINT [DF_Order Details_LastEditDate]
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Order Details] DROP COLUMN [LastEditDate]
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Order Details] DROP CONSTRAINT [DF_Order Details_CreationDate]
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
ALTER TABLE [Order Details] DROP COLUMN [CreationDate]
GO
IF @@ERROR <> 0 
     ROLLBACK TRANSACTION;


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[Order Details_Tombstone]') and TYPE = N'U') 
   DROP TABLE [Order Details_Tombstone];


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Order Details_DeletionTrigger') AND type = 'TR') 
   DROP TRIGGER [Order Details_DeletionTrigger] 

GO


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Order Details_UpdateTrigger') AND type = 'TR') 
   DROP TRIGGER [Order Details_UpdateTrigger] 

GO


IF @@TRANCOUNT > 0
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'Order Details_InsertTrigger') AND type = 'TR') 
   DROP TRIGGER [Order Details_InsertTrigger] 

GO
COMMIT TRANSACTION;
