﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Diagnostics;

namespace Beispiel
{
    public partial class TestDatenbank : Form
    {

        TestDataContext dbTest;

        public TestDatenbank()
        {
            InitializeComponent();
        }

        private void TestDatenbank_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            string filename = "'" + Application.UserAppDataPath + "\\School.mdf'";
            dbTest = new TestDataContext(@"Data Source=.\SQLEXPRESS;AttachDbFilename=" +
                     filename + ";Integrated Security=True");
            if (!dbTest.DatabaseExists()) dbTest.CreateDatabase();
            
          // Performance-Verbesserung

          //  DataLoadOptions options = new DataLoadOptions();
          //  options.LoadWith<Teacher>(Teacher => Teacher.Student);
          //  dbTest.LoadOptions = options;

          //  DataLoadOptions options = new DataLoadOptions();
          //  options.LoadWith<Teacher>(Teacher => Teacher.Bemerkungen);
          //  dbTest.LoadOptions = options;
            dbTest.Log = Console.Out;
        }

        private void button2_Click(object sender, EventArgs e)
        {
        }

        private void button3_Click(object sender, EventArgs e)
        {
            var teachers = from t in dbTest.Teacher
                           select t;
            teacherBindingSource.DataSource = teachers;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            int i = dbTest.Teacher.Where(t => t.Geburtstag < Convert.ToDateTime("31.12.1950")).Count();
            MessageBox.Show("Lehrer: " + i.ToString());
        }

        private void button5_Click(object sender, EventArgs e)
        {
            try
            {
                dbTest.SubmitChanges( ConflictMode.ContinueOnConflict);
            }
            catch
            {
                foreach (var o in dbTest.ChangeConflicts)
                    o.Resolve(RefreshMode.KeepChanges);
            }
            dbTest.SubmitChanges(ConflictMode.FailOnFirstConflict);
        }

        private void button6_Click(object sender, EventArgs e)
        {
            Teacher Lehrer = new Teacher();
            Lehrer.Nachname = "Müller";
            Lehrer.Vorname = "Heinz";
            Lehrer.Geburtstag = Convert.ToDateTime("1.1.1967");
            dbTest.Teacher.InsertOnSubmit(Lehrer);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            Teacher Lehrer = new Teacher();
            Lehrer.Nachname = "Mayer";
            Lehrer.Vorname = "Franz";
            Lehrer.Geburtstag = Convert.ToDateTime("1.1.1952");
            dbTest.Teacher.InsertOnSubmit(Lehrer);
            dbTest.SubmitChanges();
            MessageBox.Show("Die neue ID:" + Lehrer.Id.ToString());
        }

        private void button8_Click(object sender, EventArgs e)
        {
            Teacher Lehrer = new Teacher();
            Lehrer.Nachname = "Lehmann";
            Lehrer.Vorname = "Gustav";
            Lehrer.Geburtstag = Convert.ToDateTime("11.11.1950");
            Student s = new Student();
            s.Vorname = "Hans";
            s.Nachname = "Wurst";
            s.Geburtstag = Convert.ToDateTime("11.11.1981");
            Lehrer.Student.Add(s);
            dbTest.Teacher.InsertOnSubmit(Lehrer);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            Teacher Lehrer = new Teacher();
            Lehrer.Nachname = "Müller";
            Lehrer.Vorname = "Norbert";
            Lehrer.Geburtstag = Convert.ToDateTime("22.11.1972");

            Lehrer.Student.Add(new Student("Barth", "Hans", Convert.ToDateTime("4.6.1990")));
            Lehrer.Student.Add(new Student("Barth", "Jan", Convert.ToDateTime("5.6.1990")));
            Lehrer.Student.Add(new Student("Kohl", "Blumen", Convert.ToDateTime("1.4.1982")));
            dbTest.Teacher.InsertOnSubmit(Lehrer);
        }

        private void button10_Click(object sender, EventArgs e)
        {
            var q = from t in dbTest.Teacher
                    where t.Student.Count > 2
                    select t;
            teacherBindingSource.DataSource = q;
        }

        private void button11_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Der jüngste Student: " + (teacherBindingSource.Current as Teacher).Student.Max(s => s.Geburtstag).Year.ToString());
        }

        private void button12_Click(object sender, EventArgs e)
        {
            foreach (DataGridViewRow row in teacherDataGridView.SelectedRows)
            {
                MessageBox.Show(row.Cells[0].Value.ToString());
                var lehrer = dbTest.Teacher.Where(t => t.Id == (int)row.Cells[0].Value).First();
                // Und weg damit
                dbTest.Student.DeleteAllOnSubmit(lehrer.Student);
                // Und jetzt der Lehrer
                dbTest.Teacher.DeleteOnSubmit(lehrer);
                // Alternativ:    dbTest.KillTeacherById((int)row.Cells[0].Value);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                ChangeSet cs = dbTest.GetChangeSet();
                listBox1.DataSource = cs.Inserts;
                listBox2.DataSource = cs.Updates;
                listBox3.DataSource = cs.Deletes;
            }
            catch
            { }
        }

        private void button13_Click(object sender, EventArgs e)
        {
            Teacher Lehrer = new Teacher();
            Lehrer.Nachname = "Honigmund";
            Lehrer.Vorname = "Isolde";
            Lehrer.Geburtstag = Convert.ToDateTime("1.1.1987");
            teacherBindingSource.Add(Lehrer);
        }

        private void button14_Click(object sender, EventArgs e)
        {
            var teachers = (from t in dbTest.Teacher
                           select t).Skip(2).Take(3);
            teacherBindingSource.DataSource = teachers;
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            dbTest.Refresh(RefreshMode.OverwriteCurrentValues, dbTest.Teacher);
            teacherBindingSource.CurrencyManager.Refresh(); 
        }

    }
}
