﻿using System;
using System.Collections;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Xml.Linq;

using System.Data;
using System.Data.SqlClient;     
using System.Web.Configuration;             // Zugriff auf Web.Config


/// <summary>
/// Zusammenfassungsbeschreibung für DOKOWebShop
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// Um das Aufrufen dieses Webdiensts aus einem Skript mit ASP.NET-AJAX zuzulassen, heben Sie die Auskommentierung der folgenden Zeile auf. 
// [System.Web.Script.Services.ScriptService]
public class DOKOWebShop : System.Web.Services.WebService
{

    private string Connstr = WebConfigurationManager.ConnectionStrings[
                      "DatabaseConnectionString"].ToString();

    private bool AdminCheck(string email, string passwort)
    {
        bool Admin = false;
        SqlConnection conn = new SqlConnection(Connstr);
        SqlCommand cmd = new SqlCommand("CurrentUser", conn);
        cmd.CommandType = CommandType.StoredProcedure;
        cmd.Parameters.AddWithValue("@EMail", email);
        cmd.Parameters.AddWithValue("@Passwort", passwort);
        conn.Open();
        SqlDataReader dr = cmd.ExecuteReader();
        if (dr.Read())
            Admin = (bool)dr["IsAdmin"];
        conn.Close();
        return Admin;
    }


    public DOKOWebShop()
    {
        //Auskommentierung der folgenden Zeile bei Verwendung von Designkomponenten aufheben 
        //InitializeComponent(); 
    }

    [WebMethod]
    public DataSet Get_Stammdaten()
    {
        SqlConnection conn = new SqlConnection(Connstr);
        SqlDataAdapter da1 = new SqlDataAdapter("SELECT * FROM Artikel", conn);
        SqlDataAdapter da2 = new SqlDataAdapter("SELECT * FROM ArtikelGruppen", conn);
        SqlDataAdapter da3 = new SqlDataAdapter("SELECT * FROM Steuersaetze", conn);
        da1.MissingSchemaAction = MissingSchemaAction.AddWithKey;
        da2.MissingSchemaAction = MissingSchemaAction.AddWithKey;
        da3.MissingSchemaAction = MissingSchemaAction.AddWithKey;
        DataSet ds = new DataSet("Stammdaten");
        conn.Open();
        da1.Fill(ds, "Artikel");
        da2.Fill(ds, "ArtikelGruppen");
        da3.Fill(ds, "Steuersaetze");
        ds.Relations.Add("R1", ds.Tables["Artikelgruppen"].Columns["Id"],
                     ds.Tables["Artikel"].Columns["ArtikelGruppenID"]);
        ds.Relations.Add("R2", ds.Tables["Steuersaetze"].Columns["Id"],
                     ds.Tables["Artikel"].Columns["MwStSatz"]);
        conn.Close();
        return ds;
    }

    [WebMethod]
    public bool Set_Stammdaten(ref DataSet dsStammdaten, string email, string passwort)
    {
        if (AdminCheck(email, passwort))
        {
            SqlConnection conn = new SqlConnection(Connstr);
            SqlDataAdapter da1 = new SqlDataAdapter("SELECT * FROM Artikel", conn);
            SqlDataAdapter da2 = new SqlDataAdapter("SELECT * FROM ArtikelGruppen", conn);
            da1.ContinueUpdateOnError = true;
            da2.ContinueUpdateOnError = true;
            SqlCommandBuilder cb1 = new SqlCommandBuilder(da1);
            SqlCommandBuilder cb2 = new SqlCommandBuilder(da2);
            conn.Open();
            da1.Update(dsStammdaten.Tables["Artikel"]);
            da2.Update(dsStammdaten.Tables["ArtikelGruppen"]);
            conn.Close();
            return true;
        }
        else
            return false;
    }

    [WebMethod]
    public DataSet Get_Kunden()
    {
        SqlConnection conn = new SqlConnection(Connstr);
        SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM Nutzer", conn);
        da.MissingSchemaAction = MissingSchemaAction.AddWithKey;
        DataSet ds = new DataSet("Nutzer");
        conn.Open();
        da.Fill(ds, "Nutzer");
        conn.Close();
        return ds;
    }

    [WebMethod]
    public bool Set_Kunden(ref DataSet dsStammdaten, string email, string passwort)
    {
        if (AdminCheck(email, passwort))
        {
            SqlConnection conn = new SqlConnection(Connstr);
            SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM Nutzer", conn);
            da.ContinueUpdateOnError = true;
            SqlCommandBuilder cb = new SqlCommandBuilder(da);
            conn.Open();
            da.Update(dsStammdaten.Tables["Nutzer"]);
            conn.Close();
            return true;
        }
        else
            return false;
    }

    [WebMethod]
    public DataSet Get_Bestellungen()
    {
        SqlConnection conn = new SqlConnection(Connstr);
        SqlCommand cmd = new SqlCommand("Bestellliste", conn);
        cmd.CommandType = CommandType.StoredProcedure;
        SqlDataAdapter da = new SqlDataAdapter(cmd);
        DataSet ds = new DataSet("Bestellungen");
        conn.Open();
        da.Fill(ds, "Bestellungen");
        conn.Close();
        return ds;
    }

    [WebMethod]
    public DataSet Get_BestellDetails(Int32 BestellId)
    {
        SqlConnection conn = new SqlConnection(Connstr);
        SqlDataAdapter da1 = new SqlDataAdapter("SELECT * FROM Bestellungen WHERE ID=@ID",conn);
        da1.SelectCommand.Parameters.AddWithValue("@ID", BestellId);

        SqlDataAdapter da2 = new SqlDataAdapter("SELECT * FROM BestellungsDetails WHERE BestellungenID=@ID",conn);
        da2.SelectCommand.Parameters.AddWithValue("@ID", BestellId);
        
        DataSet ds = new DataSet("Rechnungsdaten");
        conn.Open();
        da1.Fill(ds, "Bestellungen");
        da2.Fill(ds, "BestellungsDetails");

        conn.Close();
        return ds;
    }


}



