﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class _Default : System.Web.UI.Page
{
    private dbShopDataContext db = new dbShopDataContext();
    private DataTable dtWarenkorb = new DataTable();

    public void GotoPage(string frm)
    {
        MyUserControl uc = (MyUserControl) Page.LoadControl(frm + ".ascx");
        uc.ID = "MyUserControl1";                // Wichtig: Zuweisen einer ID !!!
        uc.FormTree = this.TreeView1;            // Zuweisen des Navigationsbaums
        uc.Warenkorb = dtWarenkorb;
        PlaceHolder1.Controls.Clear(); 
        PlaceHolder1.Controls.Add(uc);
        ViewState["frm"] = frm;
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            // Treeview füllen
            foreach (ArtikelGruppen ag in db.ArtikelGruppen)
            {
                TreeNode tn = new TreeNode();
                tn.Text = ag.Titel;
                tn.Value = ag.Id.ToString();
                TreeView1.Nodes[0].ChildNodes.Add(tn);
            }

            // Warenkorb temporär erzeugen
            dtWarenkorb.Columns.Add("Id", Type.GetType("System.Int16"));
            dtWarenkorb.Columns.Add("Name", Type.GetType("System.String"));
            dtWarenkorb.Columns.Add("Anzahl", Type.GetType("System.Int16"));
            dtWarenkorb.Columns.Add("EPreis", Type.GetType("System.Decimal"));
            dtWarenkorb.Columns.Add("GPreis", Type.GetType("System.Decimal"));
            dtWarenkorb.Columns.Add("MWSt", Type.GetType("System.Int16"));
            Session.Add("Warenkorb", dtWarenkorb);

            // Nutzerverwaltung
            Session.Add("User", 0);       // undefinierter User
            Session.Add("Admin", false);  // keine Rechte
            Session.Timeout = 15;         // 15 Minuten
            if (Request.Cookies["Username"] != null)
                txtUserName.Text = Request.Cookies["Username"].Value;
        }
        else
        {
            if (null == Session["User"])    
                Session.Add("User", 0);       // undefinierter User

            if (null != ViewState["frm"])    // Dynamisch geladenen Controls wiederherstellen
                GotoPage(ViewState["frm"].ToString());
        }
        if ((int)Session["User"] != 0)  // Anmeldung bereits erfolgt
        {
            btnLogin.Text = "Logout";
            Panel1.Visible = false;
        }
        if (PlaceHolder1.Controls.Count == 0)
            GotoPage("Welcome");
    }

    protected void TreeView1_SelectedNodeChanged1(object sender, EventArgs e)
    {
        if (TreeView1.SelectedNode.Text.Contains("Warenkorb"))
            GotoPage("Warenkorb");
        if (TreeView1.SelectedNode.Text.Contains("Ihre Daten"))
            GotoPage("KundenKonto");
        if (TreeView1.SelectedNode.Parent != null)  // Es handelt sich um Untereinträge
        {
            if (TreeView1.SelectedNode.Parent.Text == "Shop")  // Eine Artikelrubrik
            {
                Session["Artikelgruppe"] = TreeView1.SelectedNode.Value;
                Session["ArtikelId"] = -1;
                GotoPage("Shop");
            }
        }
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        if (btnLogin.Text == "Logout")
        {
            btnLogin.Text = "Login";
            Session["User"] = 0;       // undefinierter User
            Session["Admin"] = false;  // keine Rechte
            Panel1.Visible = true;
        }
        else
        {
            var user = db.CurrentUser(txtUserName.Text, txtPasswort.Text).FirstOrDefault();  // email und passwort
            if (user != null)
            {
                Session["User"] = user.Id;
                Session["Admin"] = user.IsAdmin;
                btnLogin.Text = "Logout";
                lblMeldung.Visible = false;
                HttpCookie cookie = new HttpCookie("UserName", txtUserName.Text);
                cookie.Expires = DateTime.Now.AddDays(30); // 30 Tage gültig
                Response.Cookies.Add(cookie);
                Panel1.Visible = false;
            }
            else
            {
                btnLogin.Text = "Login";
                lblMeldung.Visible = true;
            }
        }
    }
}
